/* ===================================================================
 * AddMealForm.java
 * 
 * Copyright (c) 2004 Matt Magoffin. Created Aug 18, 2004 7:03:26 PM.
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: AddRecipeToMealForm.java 28 2009-05-04 01:19:45Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.biz.BizContext;
import magoffin.matt.ieat.domain.Course;
import magoffin.matt.ieat.domain.Meal;
import magoffin.matt.ieat.domain.MealRecipe;
import magoffin.matt.ieat.domain.Recipe;
import magoffin.matt.ieat.domain.UiData;
import magoffin.matt.ieat.domain.UiEdit;
import magoffin.matt.ieat.util.MealCommand;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.servlet.ModelAndView;

/**
 * Controller for adding a new meal.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 28 $ $Date: 2009-05-04 13:19:45 +1200 (Mon, 04 May 2009) $
 */
public class AddRecipeToMealForm extends AbstractEatWizardForm {

	@SuppressWarnings("unchecked")
	@Override
	protected Map referenceData(HttpServletRequest request, Object command,
			Errors errors, int page) throws Exception 
	{
		Map<String, Object> m =  new LinkedHashMap<String, Object>();
		UiData ui = getDomainObjectFactory().getUiDataInstance();
		m.put("uidata",ui);

		BizContext context = WebUtil.getBizContext(request, false);

		List<Meal> l = recipeBiz.getMealsForUser(context.getActingUser().getUserId(),context);
		ui.getMeal().addAll(l);
		
		List<Course> courses = recipeBiz.getAvailableCourses();
		ui.getCourse().addAll(courses);
		
		return m;
	}
	
	@Override
	protected Object formBackingObject(HttpServletRequest request)
	throws Exception 
	{
		// get the recipe ID to edit
		MealCommand mc = new MealCommand();
		ServletRequestDataBinder binder = createBinder(request, mc);
		binder.bind(request);
		
		Recipe r = recipeBiz.getRecipeById(mc.getRecipeId());
		
		MealRecipe mr = getDomainObjectFactory().getMealRecipeInstance();
		mr.setRecipe(r);
		
		mr.setCourse(getDomainObjectFactory().getCourseInstance());
		mr.setQuantity(1.0f);
		
		UiEdit edit = getDomainObjectFactory().getUiEditInstance();
		edit.setMealRecipe(mr);
		edit.setMeal(getDomainObjectFactory().getMealInstance());
		
		return edit;
	}
	
	@Override
	protected ModelAndView processFinish(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception 
	{
		// add recipe to meal
		UiEdit edit = (UiEdit)command;
		MealRecipe mr = edit.getMealRecipe();
		Meal meal = edit.getMeal();
		
		BizContext context = WebUtil.getBizContext(request, false);
		meal = recipeBiz.addRecipeToMeal(meal.getMealId(),mr,context);

		Map<String, Object> model = new LinkedHashMap<String, Object>();
		WebUtil.saveMealEdit(model,edit);
		return new ModelAndView(getSuccessView(),model);
	}
	
	@Override
	protected void validatePage(Object command, Errors errors, int page) {
		UiEdit edit = (UiEdit)command;
		MealRecipe mr = edit.getMealRecipe();
		Validator val = getValidator();
		val.validate(mr, errors);
	}
	
}
